"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var factory_1 = require("./factory");
var agent_1 = require("./agent");
var nyc_report_executor_1 = require("./nyc-report-executor");
var sl_js_infra_1 = require("sl-js-infra");
var logger_1 = require("./logger");
var upload_report_handler_1 = require("./upload-report-handler");
var nyc_report_executor_fpv6_1 = require("./nyc-report-executor-fpv6");
var LOGGER = new logger_1.LoggerFactory().getCreateApplicationLogger();
var mochaToolName = "mocha";
function init(runtimeCfg) {
    return initAsync(runtimeCfg, function () {
    });
}
exports.init = init;
function initAsync(runtimeCfg, callback, toolInfo) {
    var configLoader = new sl_js_infra_1.SlJsInfra.ConfigLoader();
    var agentCfg = configLoader.loadAgentConfiguration(runtimeCfg && runtimeCfg.toJsonObject && runtimeCfg.toJsonObject());
    var factory = new factory_1.NodeAgentFactory(agentCfg);
    var agent = factory.getCreateNodeJsAgent();
    agent.start(function (err) {
        callback(err, agent);
    }, toolInfo);
    return agent;
}
exports.initAsync = initAsync;
function getVersion() {
    return agent_1.NodeJsAgent.getVersion();
}
exports.getVersion = getVersion;
function uploadNycReport(reportFile, agentCfg, agentInstanceData) {
    if (agentCfg.footprintsEnableV6.value) {
        return uploadNycReportFPV6(reportFile, agentCfg);
    }
    return new nyc_report_executor_1.NycReportExecutor(reportFile, agentCfg, agentInstanceData).execute();
}
exports.uploadNycReport = uploadNycReport;
function uploadNycReportFPV6(reportFile, agentConfig) {
    return __awaiter(this, void 0, void 0, function () {
        var nodeAgentFactory;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    nodeAgentFactory = new factory_1.NodeAgentFactory(agentConfig);
                    return [4 /*yield*/, new nyc_report_executor_fpv6_1.NycReportExecutorFpv6(nodeAgentFactory.getCreateBackendProxy(), nodeAgentFactory.getCreateHitsCollector(), nodeAgentFactory.getCreateHitsConverter(), nodeAgentFactory.getCreateFootprintsBuffer(), agentConfig, reportFile, LOGGER).execute()];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
function startExecution(args, httpConfig, callback) {
    LOGGER.info("[EXECUTION SERVICE] about to send start execution request");
    LOGGER.debug("[START EXECUTION] execution request params are: %s", JSON.stringify(args));
    var requestCallback = function (err, body) {
        if (err) {
            LOGGER.error("[START EXECUTION] error while starting execution '%s'", err);
            callback(err);
        }
        else {
            LOGGER.info("[START EXECUTION] execution started successfully");
            callback(null);
        }
    };
    var backEndProxy = new sl_js_infra_1.SlJsInfra.BackendProxy(factory_1.NodeAgentFactory.getAgentInstanceData(), httpConfig, LOGGER);
    backEndProxy.startExecution(args, requestCallback);
}
exports.startExecution = startExecution;
function endExecution(args, httpConfig, callback) {
    LOGGER.info("[EXECUTION SERVICE] about to send end execution request");
    LOGGER.debug("[END EXECUTION] execution request params are: %s", JSON.stringify(args));
    var requestCallback = function (err, body) {
        if (err) {
            LOGGER.error("[END EXECUTION] error while trying to end execution '%s'", err);
            callback(err);
        }
        else {
            LOGGER.info("[END EXECUTION] execution ended successfully");
            callback(null);
        }
    };
    var backEndProxy = new sl_js_infra_1.SlJsInfra.BackendProxy(factory_1.NodeAgentFactory.getAgentInstanceData(), httpConfig, LOGGER);
    backEndProxy.endExecution(args, requestCallback);
}
exports.endExecution = endExecution;
function uploadReports(args, httpConfig, agentData, callback) {
    LOGGER.info("[UPLOAD REPORTS] about to upload reports");
    LOGGER.debug("[UPLOAD REPORTS] request params are: %s", JSON.stringify(args));
    var requestCallback = function (err) {
        if (err) {
            LOGGER.error("[UPLOAD REPORTS] error while trying to upload reports '%s'", err);
            callback(err);
        }
        else {
            LOGGER.info("[UPLOAD REPORTS] reports uploaded successfully");
            callback(null);
        }
    };
    var backEndProxy = new sl_js_infra_1.SlJsInfra.BackendProxy(factory_1.NodeAgentFactory.getAgentInstanceData(), httpConfig, LOGGER);
    var handler = new upload_report_handler_1.UploadReportHandler(args, backEndProxy, agentData);
    handler.upload(requestCallback);
}
exports.uploadReports = uploadReports;
function externalReport(args, httpConfig, agentData, callback) {
    LOGGER.info("[UPLOAD EXTERNAL REPORT] about to send end execution request");
    LOGGER.debug("[UPLOAD EXTERNAL REPORT] request params are: %s", JSON.stringify(args));
    var requestCallback = function (err, body) {
        if (err) {
            LOGGER.error("[UPLOAD EXTERNAL REPORT] error while trying to upload external report '%s'", err);
            callback(err);
        }
        else {
            LOGGER.info("[UPLOAD EXTERNAL REPORT] report uploaded successfully");
            callback(null);
        }
    };
    var backEndProxy = new sl_js_infra_1.SlJsInfra.BackendProxy(factory_1.NodeAgentFactory.getAgentInstanceData(), httpConfig, LOGGER);
    backEndProxy.externalReport(agentData, requestCallback);
}
exports.externalReport = externalReport;
//# sourceMappingURL=api.js.map